<script lang="ts">
  import CardBack from "./CardBack.svelte";
  import { send, receive } from "./crossfade";

  /*
    Beginning of the array = bottom of the deck
  */
  export let deck: Card[];

  $: size = deck.length;
</script>

<div class="deck">
  {#each deck as card, idx (card)}
    <div style={`transform: translate(-${idx * 0.12}em, -${idx * 0.12}em);`}>
      <div in:receive={{ key: card }} out:send={{ key: card }}>
        <CardBack />
      </div>

      {#if idx === size - 1}
        <div class="size-wrapper">
          <div class="size">&times; {size}</div>
        </div>
      {/if}
    </div>
  {/each}
</div>

<style>
  .deck {
    position: relative;
  }
  .deck > *:first-child {
    position: relative;
  }
  .deck > * {
    position: absolute;
    top: 0;
    left: 0;
  }

  .size-wrapper {
    top: -14em;
    position: relative;
    height: 14em;
    width: 10em;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  .size {
    font-size: 2em;

    background-color: linen;
    padding: 0 0.5em;
    border-radius: 0.4rem;

    display: flex;
    align-items: center;
    justify-content: center;
  }
</style>
